/*
 * Jalview - A Sequence Alignment Editor and Viewer (Version 2.8.2)
 * Copyright (C) 2014 The Jalview Authors
 * 
 * This file is part of Jalview.
 * 
 * Jalview is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *  
 * Jalview is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty 
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE.  See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Jalview.  If not, see <http://www.gnu.org/licenses/>.
 * The Jalview Authors are detailed in the 'AUTHORS' file.
 */
package jalview.ws.jws2;

import jalview.api.AlignViewportI;
import jalview.api.AlignmentViewPanel;
import jalview.gui.AlignFrame;
import jalview.ws.jws2.dm.AAConSettings;
import jalview.ws.jws2.jabaws2.Jws2Instance;
import jalview.ws.params.WsParamSetI;

import java.util.List;

import compbio.metadata.Argument;

public abstract class JabawsAlignCalcWorker extends JabawsCalcWorker
{

  public JabawsAlignCalcWorker(AlignViewportI alignViewport,
          AlignmentViewPanel alignPanel)
  {
    super(alignViewport, alignPanel);
  }

  public JabawsAlignCalcWorker(Jws2Instance service, AlignFrame alignFrame,
          WsParamSetI preset, List<Argument> paramset)
  {
    super(service, alignFrame, preset, paramset);
  }

  /**
   * Recover any existing parameters for this service
   */
  protected void initViewportParams()
  {
    ((jalview.gui.AlignViewport) alignViewport).setCalcIdSettingsFor(
            getCalcId(),
            new AAConSettings(true, service, this.preset,
                    (arguments != null) ? JabaParamStore
                            .getJwsArgsfromJaba(arguments) : null), true);
  }

  /**
   * 
   * @return
   */
  public abstract String getCalcId();

  @Override
  public void updateParameters(WsParamSetI newpreset,
          java.util.List<Argument> newarguments)
  {
    super.updateParameters(newpreset, newarguments);
    initViewportParams();
  }
}
